/*
 * PropertyChangeMediator.java  $Revision: 1.2 $  $Date: 2007/10/03 04:39:39 $
 *
 * Copyright (C) 2007 Meldcraft Corporation
 *
 * This file is part of Scaffold.
 * 
 * Scaffold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scaffold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Scaffold.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.meldcraft.application.guis.mvc;

import java.awt.Component;
import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;

import javax.swing.JFormattedTextField;

import com.meldcraft.application.ApplicationContext;
import com.meldcraft.application.ApplicationContextEvent;
import com.meldcraft.application.ApplicationContextListener;
import com.meldcraft.util.ReflectUtil;

/**
 * @version $Revision: 1.2 $ $Date: 2007/10/03 04:39:39 $
 * @author Rob Richards
 */
public class PropertyChangeMediator extends PropertyChangeEmitter implements ApplicationContextListener
{
    private Component   mTarget;
    public PropertyChangeMediator(ApplicationContext context, String elementId, Component comp)
    {
        super(context, elementId, comp);
        mTarget = comp;
        context.addApplicationContextListener(this, elementId + ".valueChanged");
    }

    public void applicationContextChanged(ApplicationContextEvent e)
    {
        try
        {
            Object curVal = ReflectUtil.invokeMethod(mTarget, "getValue");
            Object newVal = e.getValue();
            if (curVal != newVal)
            {
                if ((curVal == null) ||
                    (newVal == null) ||
                    !curVal.equals(newVal))
                {
                    if ((newVal != null) && (mTarget instanceof JFormattedTextField))
                    {
                        JFormattedTextField text = (JFormattedTextField)mTarget;
                        try
                        {
                            newVal = text.getFormatter().stringToValue(String.valueOf(newVal));
                        }
                        catch (ParseException e1)
                        {
                        }
                    }
                    ReflectUtil.invokeMethod(mTarget, "setValue", newVal);
                }
            }
        }
        catch (NoSuchMethodException e1)
        {
        }
        catch (IllegalAccessException e1)
        {
        }
        catch (InvocationTargetException e1)
        {
        } 
    }
}



